//
// Copyright 2004-present Facebook. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSInteger, XCToolExitStatus) {
  XCToolAllActionsSucceeded = 0,
  XCToolActionFailed = 1,
  XCToolNotCompatibleVersionOfXcode = 2,
  XCToolArgsFileIsBroken = 3,
  XCToolArgumentsValidationFailed = 4,
  XCToolReporterOptionsValidationFailed = 5,
  XCToolReporterInitializationFailed = 6,
  XCToolXcodeInfoValidationFailed = 7,

  XCToolHelpShown = 0,
  XCToolVersionShown = 0,
};

@interface XCTool : NSObject

@property (nonatomic, strong) NSFileHandle *standardOutput;
@property (nonatomic, strong) NSFileHandle *standardError;
@property (nonatomic, copy) NSArray *arguments;
@property (nonatomic, assign) XCToolExitStatus exitStatus;

- (void)run;

@end
